<script>
import _ from 'lodash';
import { mapState } from 'vuex';

import * as helperFilters from '~/helpers/filters.js';

import AnimRigPublicLibCard from '~/components/anim-rig/public-lib-card.vue';

export default {
  name: `anim-rig-public-libs-dashboard`,
  components: { AnimRigPublicLibCard },
  props: {
    libs: { type: Array, required: true },
    showInactive: { type: Boolean, required: true },
  },
  data() {
    return {
      dragging: false,
    }
  },
  filters: {
    capitalize: helperFilters.capitalize,
  },
  computed: {
    localShowInactive: {
      get() {
        return this.showInactive;
      },
      set(val) {
        this.$emit(`set-inactive`, val);
      }
    },
    ...mapState({
      isAnimLead: (state) => state.users.currentUser.roles.includes(`anim-lead`),
    }),
    nLibs() {
      return this.libs.length;
    },
  },
  methods: {
    startDrag (e, item) {
      e.dataTransfer.dropEffect = 'move';
      e.dataTransfer.effectAllowed = 'move';
      e.dataTransfer.setData('id', item.id);
      this.dragging = true;
    },
    onDrop (e, target) {
      let id = e.dataTransfer.getData('id');
      if (typeof id === `string`) {
        id = parseInt(id);
      }
      this.dragging = false;
      if (target !== null && id === target.id) { // cannot itself as parent!
        return;
      }
      const item = _.find(this.items, [ `id`, id ]);
      this.$emit(`set-parent-lib`, { itemId: id, parentId: (target !== null) ? target.id : null });
    },
    setLibraryName (data) {
      this.$emit(`set-name`, data);
    },
    toggleLibraryFavorite (idx, on) {
      this.$emit(`toggle-favorite`, { idx, on });
    },
    unpublishLibrary (idx) {
      this.$emit(`unpublish`, idx);
    },
    deleteLibrary (idx) {
      this.$emit(`delete`, idx);
    },
    reviveLibrary (idx) {
      this.$emit(`revive`, idx);
    },
  },
}
</script>

<template>
  <cbr-dashboard
    v-if="isAnimLead"
    :title="$tc(`anim-rig.public-libs.title`, 2)"
    :dragging="dragging"
    :onDrop="(e) => onDrop(e, null)"
  >
    <template v-slot:title-commands>
      <v-row align="center">
        <v-switch
          v-model="localShowInactive"
          :label="$t(`common.show-inactive`)"
          class="mr-4 my-0 py-0"
          hide-details
        />
        <div class="text-sm-caption my-0 mr-4">
          {{ nLibs }} {{ $tc(`common.library`, nLibs) }}
        </div>
      </v-row>
    </template>
    <div v-for="(lib, idx) in libs"
          :key="lib.name"
          @drop="onDrop($event, lib)"
          @dragover.prevent
          @dragenter.prevent>
      <anim-rig-public-lib-card
        :is-anim-lead="isAnimLead"
        :lib="lib"
        @set-name="(name) => setLibraryName({ idx, name })"
        @toggle-favorite="(on) => toggleLibraryFavorite(idx, on)"
        @unpublish="() => unpublishLibrary(idx)"
        @delete="() => deleteLibrary(idx)"
        @revive="() => reviveLibrary(idx)"
        draggable
        @dragstart.native="startDrag($event, lib)"
      />
    </div>
  </cbr-dashboard>
  <cbr-dashboard v-else :title="$tc(`anim-rig.public-libs.title`, 2)">
    <template v-slot:title-commands>
      <v-row align="center">
        <v-switch
          v-model="localShowInactive"
          :label="$t(`common.show-inactive`)"
          class="mr-4 my-0 py-0"
          hide-details
        />
        <div class="text-sm-caption my-0 mr-4">
          {{ nLibs }} {{ $tc(`common.library`, nLibs) }}
        </div>
      </v-row>
    </template>
    <anim-rig-public-lib-card
      v-for="(lib, idx) in libs"
      :key="lib.name"
      :is-anim-lead="isAnimLead"
      :lib="lib"
      @set-name="(name) => setLibraryName({ idx, name })"
      @toggle-favorite="(on) => toggleLibraryFavorite(idx, on)"
      @unpublish="() => unpublishLibrary(idx)"
      @delete="() => deleteLibrary(idx)"
      @revive="() => reviveLibrary(idx)"
    />
  </cbr-dashboard>
</template>
